#!/usr/bin/env python
# Copyright (C) 2011-2012 Linaro Limited
#
# Author: Zygmunt Krynicki <zygmunt.krynicki@linaro.org>
#
# This file is part of lava-core
#
# lava-core is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License version 3
# as published by the Free Software Foundation
#
# lava-core is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with lava-core.  If not, see <http://www.gnu.org/licenses/>.

from json_document.serializers import JSON
from lava.core.history import history


def get_food():
    history.info("opening fridge")
    history.info("taking the cake out")


def nested():
    history.debug("hmm")
    history.debug("I wonder if this works")


def chew_food():
    with history.info("nested"):
        nested()
    history.info("putting cake in mouth")
    try:
        with history.info("chewing"):
            raise Exception("nail in cake!")
    except:
        history.warning("removed nail")
    history.info("still eating")


def eat_food():
    history.info("opening mouth")
    chew_food()


with history.info("eating {food}", food="cake", icing="cherry"):
    get_food()
    eat_food()


print JSON.dumps(history.top.as_json())
history.top.print_()
